//  TopUpDownFiles/NT is a bulletinmaker program for the
//  BBBS bulletin board system. Copyright 2001 (c) PowerLink BBS.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  PowerLink can be reached at:
//
//     PowerLink BBS
//
//     Node 1  : 47-38094149 (64k ISDN)
//     Node 2  : 47-38025696 (33k Modem)
//     WWW     : http://home.online.no/~bigerik/
//     E-Mail  : bigerik@online.no
//     Fidonet : 2:211/50 - 2:211/51

#include <stdio.h>
#include <time.h>

#define num_active 17
#define num_notwanted 2
#define true  1
#define false 0
#define version "v2.0"

#define NOCOL 36
#define UNCOL 35
#define UCOL 32
#define DNCOL 35
#define DCOL 32

#define HOWD
#define LINUX

struct one_user
{
  char         name[30];
  unsigned long files_updown;
};

struct one_user most_active_up[num_active];
struct one_user most_active_down[num_active];
#ifdef HOWD
  unsigned char usr_buffer[273];
#else
  unsigned char usr_buffer[239];
#endif
unsigned char not_wanted[num_notwanted][30];
unsigned long files_up, files_down;


FILE *open_file(char *filename)
{
  FILE *fhandle;

  if (!(fhandle=fopen(filename,"rb")))
    return(false);
  return(fhandle);
}


int read_one_user(FILE *fh_usr, char *usr_buffer)
{
  if (!feof(fh_usr))
  {
#ifdef HOWD
    fread(usr_buffer,273,1,fh_usr);
#else
    fread(usr_buffer,239,1,fh_usr);
#endif
    return(true);
  }
  return(false);
}

void clear_active()
{
  int t;

  for(t=0;t>num_active;t++)
  {
    most_active_up[t].name[0]='\0';
    most_active_up[t].files_updown=0;
    most_active_down[t].name[0]='\0';
    most_active_down[t].files_updown=0;
  }
}

void read_unwanted(FILE *fil)
{
  int t=0;
  unsigned char *tmp;

  while (!feof(fil) && (t<num_notwanted))
  {
    fgets(&not_wanted[t][0],30,fil);
    tmp=strchr(&not_wanted[t++][0],'\n');
    *tmp='\0';
  }
}

int unwanted(FILE *data)
{
  int t;

  if (!data) return(false);
  for(t=0;t<num_notwanted;t++)
#ifdef LINUX
    if (strcasecmp(&not_wanted[t][0],&usr_buffer[0])==0)
#else
    if (strcmpi(&not_wanted[t][0],&usr_buffer[0])==0)
#endif
      return(true);
  return(false);
}

void insert_beforenode_up(int offset)
{
  int t,i;

  for(t=num_active-1;t>offset;t--)
  {
    for (i=0;i<30;i++)
      most_active_up[t].name[i]=most_active_up[t-1].name[i];
    most_active_up[t].files_updown=most_active_up[t-1].files_updown;
  }
  for (i=0;i<30;i++)
    most_active_up[offset].name[i]=usr_buffer[i];
  most_active_up[offset].files_updown=files_up;
}

void insert_beforenode_down(int offset)
{
  int t,i;

  for(t=num_active-1;t>offset;t--)
  {
    for (i=0;i<30;i++)
      most_active_down[t].name[i]=most_active_down[t-1].name[i];
    most_active_down[t].files_updown=most_active_down[t-1].files_updown;
  }
  for (i=0;i<30;i++)
    most_active_down[offset].name[i]=usr_buffer[i];
  most_active_down[offset].files_updown=files_down;
}

char format_numbers_up(int offset)
{
  int t;

  for (t=0;t<4;t++)
  {
    if (most_active_up[offset].files_updown<=1023)
    {
     if (t==0) return('k');
     else if (t==1) return('m');
     else if (t==2) return('g');
     else if (t==3) return('t');      // you've got one hell of a user :-)
    }
    most_active_up[offset].files_updown/=1024;
  }
}

char format_numbers_down(int offset)
{
  int t;

  for (t=0;t<4;t++)
  {
    if (most_active_down[offset].files_updown<=1023)
    {
     if (t==0) return('k');
     else if (t==1) return('m');
     else if (t==2) return('g');
     else if (t==3) return('t');      // you've got a hell of a user :-)
    }
    most_active_down[offset].files_updown/=1024;
  }
}

write_bull()
{
  int t;
  char unit1,unit2;
  time_t time_now;

  time(&time_now);
  printf("\[2J");
  printf("\[0;0H\[1;37mTop Up/Down (\[1;33mBytes\[1;37m)\[1;30m (c) 2001 PowerLink \[1;36m Last Updated \[0;36m%s\r\n",ctime(&time_now));
  printf("\[1;%umN\[0;%umo  \[1;%umN\[0;%umame                            \[1;%umU\[0;%umpls \[1;%umN\[0;%umame                            \[1;%umD\[0;%umwns\r\n", NOCOL, NOCOL, UNCOL, UNCOL, UCOL, UCOL, DNCOL, DNCOL, DCOL, DCOL);
  printf("\[1;30m--  ------------------------------ ----- ------------------------------ -----\r\n");
  for(t=0;t<num_active;t++)
  {
    unit1=format_numbers_up(t);
    unit2=format_numbers_down(t);
    printf("\[1;%um%2d  \[%um%-30s \[%um%4lu%c \[%um%-30s \[%um%4lu%c\r\n",NOCOL,t+1,UNCOL,most_active_up[t].name,UCOL,most_active_up[t].files_updown,unit1,DNCOL,most_active_down[t].name,DCOL,most_active_down[t].files_updown,unit2);
  }
  printf("\[0m\r\n");
}


int main(int argc, char *argv[])
{

  FILE *fh_usr, *fh_not;
  int t;

  if (argc==2)
    if (strcmp(argv[1],"-V")==0)
    {
      printf("\nTopDwupb/NT %s. Copyright 2001 (c) PowerLink\n",version);
      printf("Free Software under GNU General Public License. NO WARRANTY.\n\n");
      return(1);
    }
  if (argc>=4 || argc==1)
  {
    printf("\nUsage: topdwupb [-V] [user_rec_filename] [unwanted_filename]\n\n");
    return(1);
  }

  if(!(fh_usr=open_file(argv[1])))
  {
    printf("\nERRORS 1: Can't open the file '%s'.\n\n",argv[1]);
    return(-1);
  }
  if(argc==3)
    if(!(fh_not=open_file(argv[2])))
    {
      printf("\nERRORS 1: Can't open the file '%s'.\n\n",argv[2]);
      return(-1);
    }

  clear_active();
  if (fh_not) read_unwanted(fh_not);
  while(read_one_user(fh_usr, usr_buffer))
  { 
    if ((usr_buffer[142]==0) && (unwanted(fh_not)==false))
    {
#ifdef HOWD
      files_up=usr_buffer[209]+(usr_buffer[210]*256)+(usr_buffer[211]*256*256)+(usr_buffer[212]*256*256*256);
      files_down=usr_buffer[217]+(usr_buffer[218]*256)+(usr_buffer[219]*256*256)+(usr_buffer[220]*256*256*256);
#else
      files_up=usr_buffer[203]+(usr_buffer[204]*256)+(usr_buffer[205]*256*256)+(usr_buffer[206]*256*256*256);
      files_down=usr_buffer[207]+(usr_buffer[208]*256)+(usr_buffer[209]*256*256)+(usr_buffer[210]*256*256*256);
#endif
      if (files_up!=0)
      {
        for (t=0;t<num_active;t++)
        {
          if (files_up>=most_active_up[t].files_updown)
          {
            insert_beforenode_up(t);
            break;
          }
        }
      }
      if (files_down!=0)
      {
        for (t=0;t<num_active;t++)
        {
          if (files_down>=most_active_down[t].files_updown)
          {
            insert_beforenode_down(t);
            break;
          }
        }
      }
    }
  }
  write_bull();
  fclose(fh_usr);
  if (argc==3) fclose(fh_not);
  return(0);
}
